<?php

register_activation_hook(__FILE__, 'install');

if(!class_exists("StormationMassMessagingPlugin")){
	class StormationMassMessagingPlugin{
		function addHeaderCode(){
			global $bp;
			?>
			<!-- Using Stormation's 'Mass Messaging' plugin from stormation.info -->
			<?php
			if($bp->current_component == 'messages' && $bp->current_action == 'mass-messaging'){
				?>
				<script language="JavaScript">
					function toggle(source, action) {
						checkboxes = document.getElementsByName(action);
						for(var i in checkboxes)
    						checkboxes[i].checked = source.checked;
					}
				</script>
			<?php
			}
		}
		function addAdminMenus(){						
			add_menu_page('Mass Messaging', 'Mass Messaging', 'manage_options', 'MassMessagingOptions', 'displayAdminOptionsPage' );
			function displayAdminOptionsPage(){
    			if(!current_user_can('manage_options')){
      				wp_die( __('You do not have sufficient permissions to access this page.') );
    			}else{	
    				echo "<h2><u>Mass Messaging Options</u></h2>";
					if(isset($_POST['update_MassMessagingOtions'])){
						if(isset($_POST['update_MassMessagingEvents'])){
               				update_option('MassMessagingEvents',$_POST['update_MassMessagingEvents']);
                		}  
               			if(isset($_POST['update_MassMessagingAllEvents'])){
               				update_option('MassMessagingAllEvents',$_POST['update_MassMessagingAllEvents']);
                		} 
						if(isset($_POST['update_MassMessagingGroups'])){
               				update_option('MassMessagingGroups',$_POST['update_MassMessagingGroups']);
                		}  
               			if(isset($_POST['update_MassMessagingAllGroups'])){
               				update_option('MassMessagingAllGroups',$_POST['update_MassMessagingAllGroups']);
                		}   
                		if(isset($_POST['update_MassMessagingMembers'])){
                    		update_option('MassMessagingMembers',$_POST['update_MassMessagingMembers']);
                		}   
                		if(isset($_POST['update_MassMessagingAllMembers'])){
                    		update_option('MassMessagingAllMembers',$_POST['update_MassMessagingAllMembers']);
                		}
                		?>
						<div class="updated"><p><strong>Options Updated</strong></p></div>
						<?php
					}
					if(isset($_POST['reset_MassMessagingOtions'])){
						update_option('MassMessagingEvents');
						update_option('MassMessagingAllEvents');
						update_option('MassMessagingGroups', 'true');
						update_option('MassMessagingAllGroups', 'true');
						update_option('MassMessagingMembers', 'true');
						update_option('MassMessagingAllMembers', 'true');
						?>
						<div class="updated"><p><strong>Options Reset</strong></p></div>
						<?php
					}
					$oldMassMessagingEvents = get_option('MassMessagingEvents');
					$oldMassMessagingAllEvents = get_option('MassMessagingAllEvents');
					$oldMassMessagingGroups = get_option('MassMessagingGroups');
					$oldMassMessagingAllGroups = get_option('MassMessagingAllGroups');
					$oldMassMessagingMembers = get_option('MassMessagingMembers');
					$oldMassMessagingAllMembers = get_option('MassMessagingAllMembers');
					?>
					<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
						<h3>Allow mass messaging to groups?:</h3>
						<input type="radio" name="update_MassMessagingGroups" value="true" <?php if($oldMassMessagingGroups == 'true'){echo "checked";} ?>> Yes<br>
						<input type="radio" name="update_MassMessagingGroups" value="false" <?php if($oldMassMessagingGroups == 'false'){echo "checked";} ?>> No<br>
						<hr />
						<h3>Allow mass messaging to select all groups?:</h3>
						<input type="radio" name="update_MassMessagingAllGroups" value="true" <?php if($oldMassMessagingAllGroups == 'true'){echo "checked";} ?>> Yes<br>
						<input type="radio" name="update_MassMessagingAllGroups" value="false" <?php if($oldMassMessagingAllGroups == 'false'){echo "checked";} ?>> No<br>
						<hr />
						<h3>Allow mass messaging to members?:</h3>
						<input type="radio" name="update_MassMessagingMembers" value="true" <?php if($oldMassMessagingMembers == 'true'){echo "checked";} ?>> Yes<br>
						<input type="radio" name="update_MassMessagingMembers" value="false" <?php if($oldMassMessagingMembers == 'false'){echo "checked";} ?>> No<br>
						<hr />
						<h3>Allow mass messaging to select all members?:</h3>
						<input type="radio" name="update_MassMessagingAllMembers" value="true" <?php if($oldMassMessagingAllMembers == 'true'){echo "checked";} ?>> Yes<br>
						<input type="radio" name="update_MassMessagingAllMembers" value="false" <?php if($oldMassMessagingAllMembers == 'false'){echo "checked";} ?>> No<br>
						<hr />
						<h3>Allow mass messaging to events (requires EventPress)?:</h3>
						<input type="radio" name="update_MassMessagingEvents" value="true" <?php if($oldMassMessagingEvents == 'true'){echo "checked";} ?>> Yes<br>
						<input type="radio" name="update_MassMessagingEvents" value="false" <?php if($oldMassMessagingEvents == 'false'){echo "checked";} ?>> No<br>
						<hr />
						<h3>Allow mass messaging to select all events (requires EventPress)?:</h3>
						<input type="radio" name="update_MassMessagingAllEvents" value="true" <?php if($oldMassMessagingAllEvents == 'true'){echo "checked";} ?>> Yes<br>
						<input type="radio" name="update_MassMessagingAllEvents" value="false" <?php if($oldMassMessagingAllEvents == 'false'){echo "checked";} ?>> No<br>
						<hr />
						<input type="submit" name="update_MassMessagingOtions" value="Update Settings" />
					</form>
					<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
					<input type="submit" name="reset_MassMessagingOtions" value="Reset to defaults" />
					</form>
                <?php

				}
			}
		}
		function setupNavigation(){
			global $bp, $current_user;
			get_currentuserinfo();
			
			bp_core_new_subnav_item( array(
   				'name' => 'Mass Messaging',
   				'slug' => 'mass-messaging',
   				'parent_url' => home_url().'/members/'.$current_user->user_login.'/messages/',
   				'parent_slug' => 'messages',
   				'screen_function' => 'mass_messaging_page_screen',
   				'position' => 40 ) );
		
			function mass_messaging_page_screen(){
    			add_action( 'bp_template_title', 'mass_messaging_page_screen_title' );
    			add_action( 'bp_template_content', 'mass_messaging_page_screen_content' );
    			bp_core_load_template( apply_filters( 'bp_core_template_plugin', 'members/single/plugins' ) );
			}

    		function mass_messaging_page_screen_title(){
        		echo 'Mass Messaging';
    		}
    		function mass_messaging_page_screen_content(){
    			ini_set('display_errors', false); 
    			global $wpdb;
    			global $bp;
    			    			
    			$users = array();
    			$subject = $_POST['subject'];
    			$content = $_POST['content'];
    			
    			$events = $_POST['events'];
    			if(!empty($events)){
    				$eventsCount = count($events);
    				for($i=0; $i < $eventsCount; $i++){
    					$registrants = $wpdb->get_col("SELECT post_author FROM {$wpdb->posts} WHERE post_status = 'reg_approved' AND post_type = 'ep_reg' AND post_parent = $events[$i]");
    					foreach($registrants as $registrant){
    						array_push($users, $registrant);
    					}
    				}
    			}
    			$groups = $_POST['groups'];
  				if(!empty($groups)){
    				$groupCount = count($groups);
    				for($i=0; $i < $groupCount; $i++){
    					$groupMembers = $wpdb->get_col( $wpdb->prepare( "SELECT user_id FROM {$bp->groups->table_name_members} WHERE group_id = %d AND is_confirmed = 1 AND is_banned = 0", $groups[$i] ) );
  						$groupMembersCount = count($groupMembers);
    					for($i=0; $i < $groupMembersCount; $i++){
      						array_push($users, $groupMembers[$i]);
      					}
      				}
 				}
 				$members = $_POST['members'];
  				if(!empty($members)){
    				$membersCount = count($members);
    				for($i=0; $i < $membersCount; $i++){
      					array_push($users, $members[$i]);
      				}
 				}
 				$usersFinal = array_unique($users, SORT_NUMERIC);
 				$sent = 0;
 				$sender = $bp->loggedin_user->id;
 				foreach ($usersFinal as $value) {
 					if($value != $sender){
						if( messages_new_message( array('sender_id' => $sender, 'subject' => $subject, 'content' => $content, 	'recipients' => $value ) ) ){
							$sent++;
						}
					}
					if ( $sent % 50 == 0 )
						sleep(5);
				}
				if($sent > 0){
					if($sent != 1){
						echo "Messages sent to ".$sent." people";
					}else{
						echo "Message sent to 1 person";
					}
				}
				$MassMessagingEvents = get_option('MassMessagingEvents');
				$MassMessagingAllEvents = get_option('MassMessagingAllEvents');
				$MassMessagingGroups = get_option('MassMessagingGroups');
				$MassMessagingAllGroups = get_option('MassMessagingAllGroups');
				$MassMessagingMembers = get_option('MassMessagingMembers');
				$MassMessagingAllMembers = get_option('MassMessagingAllMembers');
    			?>
    			<form action="" method="post" id="send_message_form" class="standard-form">
				
				<label for="subject">Subject</label>
				<input type="text" name="subject" id="subject" value="" />

				<label for="content">Message</label>
				<textarea name="content" id="message_content" rows="15" cols="40"></textarea>
					
				<?php if($MassMessagingAllEvents == 'true'){ ?>
				
				<h3>All Events</h3>
				<input type=checkbox onClick="toggle(this, 'events[]')" >All Events<br />
				
				<?php } ?>
				<?php if($MassMessagingEvents == 'true'){
				
				$events = $wpdb->get_col("SELECT ID FROM {$wpdb->posts} WHERE post_status = 'publish' AND post_type = 'ep_event'");
				$eventsCount = count($events);
				
				if ( $eventsCount != 0) : ?>
					<h3>Events</h3>
					<?php foreach($events as $event){
						$thisEvent = $wpdb->get_row( "SELECT * FROM $wpdb->posts WHERE ID = $event");
						?>
						<input type=checkbox name="events[]" value="<?php echo $thisEvent->ID; ?>"><?php echo $thisEvent->post_title; ?>
						<br />
					<?php } ?>
				<?php endif; ?>
				
				<?php } ?>
				
				<?php if($MassMessagingAllGroups == 'true'){ ?>
				
				<h3>All Groups</h3>
				<input type=checkbox onClick="toggle(this, 'groups[]')" >All Groups<br />
				
				<?php } ?>
				<?php if($MassMessagingGroups == 'true'){ ?>
				
				<?php if ( bp_has_groups('type=newest&per_page=999&user_id='.$bp->loggedin_user->id) ) : ?>
					<h3>Groups</h3>
					<?php while ( bp_groups() ) : bp_the_group(); ?>
						<input type=checkbox name="groups[]" value="<?php bp_group_id(); ?>"><?php bp_group_name(); ?>
						<br />
					<?php endwhile; ?>
				<?php endif; ?>
				
				<?php } ?>
				<?php if($MassMessagingAllMembers == 'true'){ ?>
				
				<h3>All Members</h3>
				<input type=checkbox onClick="toggle(this, 'members[]')" >All Members<br />
				
				<?php } ?>
				<?php if($MassMessagingMembers == 'true'){ ?>
				
				<?php if ( bp_has_members('per_page=999') ) : ?>
					<h3>Members</h3>
					<?php while ( bp_members() ) : bp_the_member(); ?>
						<input type=checkbox name="members[]" value="<?php bp_member_user_id(); ?>"><?php bp_member_name(); ?><br />
					<?php endwhile; ?>
				<?php endif; ?>
				
				<?php } ?>
				
				<input type="submit" value="Send Message &rarr;" name="send" id="send" />
        	<?php
        	ini_set('display_errors', true);
    		}
   		}
	}
}

if(class_exists("StormationMassMessagingPlugin")){
	$S_MassMessaging = new StormationMassMessagingPlugin();
}

if(isset($S_MassMessaging)){
	add_action('wp_head', array(&$S_MassMessaging, 'addHeaderCode'), 1);
	add_action('bp_setup_nav', array(&$S_MassMessaging, 'setupNavigation'), 1);
	add_action('admin_menu', array(&$S_MassMessaging,'addAdminMenus'), 1);
}

function install(){
	add_option('MassMessagingEvents', 'false');
	add_option('MassMessagingAllEvents', 'false');
	add_option('MassMessagingGroups', 'true');
	add_option('MassMessagingAllGroups', 'true');
	add_option('MassMessagingMembers', 'true');
	add_option('MassMessagingAllMembers', 'true');
}
?>